[![status-badge](https://ci.hackmi.ch/api/badges/11/status.svg)](https://ci.hackmi.ch/repos/11)

# Goshorly
**Easy-to-use, self-hosted link shortener built with Golang and Redis.**

Lightweight, fast, and Docker-compatible for seamless deployment. ❤️

---

### Features

- Self-hosted: Take control of your link shortening service.
- Built with Golang: High performance and reliability.
- Redis Integration: Efficient data storage.
- Easy Deployment: Docker, Binary, Build it yourself
- Docker Support: ( linux/amd64, linux/arm/v6, linux/arm64/v8 )

---

### Installation
#### Using Docker
(please refer to the example files!)

``` bash
git clone https://github.com/yourusername/goshorly.git
cd goshorly
docker-compose up -d
```

To simplify your deployment, we offer the following Docker tags:

- dev: Latest code from the main branch (experimental).
- latest: Latest stable release (may include breaking changes).
- Versioned Tags (vX, vX.X, vX.X.X): Specific release versions.

#### Using Binary
1. Download the latest binary from the releases.
2. Create an .env file (or use the .env.example) 
and change the values for your environment.
3. Run the binary the terminal.

---

### Contributing

We welcome contributions!
If you have feature requests, bug reports, or improvements, feel free to:

- Open an issue.
- Fork the repository.
- Create a new branch (feature/awesome-feature).
- Submit a pull request with detailed explanations.
- Submit a review.